﻿using Syncfusion.SfGauge.XForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection.Emit;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SyncFusion
{
    public class Gauge : ContentPage
    {
        public Gauge()
        {

            int pointerValue = 72;

            var viewLayout = new StackLayout
            {
                Padding = 10,
                //VerticalOptions = LayoutOptions.FillAndExpand,
                HorizontalOptions = LayoutOptions.FillAndExpand,
            };

            SfCircularGauge circularGauge = new SfCircularGauge();
            circularGauge.HeightRequest = 100;
            circularGauge.GaugeType = GaugeType.North;

            // to add a scale
            Scale scale = new Scale();
            scale.StartValue = 0;
            scale.EndValue = 100;
            scale.Interval = 100;
            scale.StartAngle = 180;
            scale.SweepAngle = 180;
            scale.RimThickness = 30;
            scale.RimColor = Color.Transparent;
            scale.ShowTicks = false;
            scale.ShowLabels = true;
            scale.LabelOffset = 0.15;
            //scale.LabelOffset = 0.4;
            scale.LabelColor = Color.Gray;
            scale.LabelFontSize = Device.GetNamedSize(NamedSize.Small, typeof(Label));
           
             //Scale added below
			//circularGauge.Scales.Add(scale);

            //1
            Range range1 = new Range();
            range1.StartValue = 0;
            range1.EndValue = 20;
            range1.Color = Color.Red;
            range1.Thickness = 30;
            scale.Ranges.Add(range1);

            //2
            Range range2 = new Range();
            range2.StartValue = 20;
            range2.EndValue = 40;
            range2.Color = Color.Purple;
            range2.Thickness = 30;
            scale.Ranges.Add(range2);

            //3
            Range range3 = new Range();
            range3.StartValue = 40;
            range3.EndValue = 60;
            range3.Color = Color.Pink;
            range3.Thickness = 30;
            scale.Ranges.Add(range3);

            //4
            Range range4 = new Range();
            range4.StartValue = 60;
            range4.EndValue = 80;
            range4.Color = Color.Yellow;
            range4.Thickness = 30;
            scale.Ranges.Add(range4);

            //5
            Range range5 = new Range();
            range5.StartValue = 80;
            range5.EndValue = 100;
            range5.Color = Color.Red;
            range5.Thickness = 30;
            scale.Ranges.Add(range5);

            NeedlePointer needlePointer = new NeedlePointer();
            needlePointer.EnableAnimation = true;
            needlePointer.Type = PointerType.Triangle;
            needlePointer.Value = 90;
            needlePointer.Thickness = 5;
            needlePointer.KnobRadius = 20;
            needlePointer.LengthFactor = 0.8;
            needlePointer.Color = Color.Red;
            

            scale.Pointers.Add(needlePointer);

           circularGauge.Scales.Add(scale);
           
			circularGauge.SizeChanged += async (object sender, EventArgs e) => {
                await Task.Delay(TimeSpan.FromSeconds(1));
                needlePointer.Value = 50;
            };

            viewLayout.Children.Add(new Label
            {
                Text = "Delight Score " + pointerValue + "%",
                TextColor = Color.Black,
                HorizontalTextAlignment = TextAlignment.Start,
                VerticalTextAlignment = TextAlignment.Center,
            });
            viewLayout.Children.Add(circularGauge);

			StackLayout sc = new StackLayout ();
			sc.VerticalOptions = LayoutOptions.FillAndExpand;

			Button b = new Button ();
			b.Text = "fff";
			Button b1 = new Button ();
			b1.Text = "ffeeeeef";
			sc.Children.Add (b);

			sc.Children.Add (b1);
			sc.Children.Add (b);
			sc.Children.Add (b);
			sc.Children.Add (b);



			Content = sc;//circularGauge;

            Title = "Gauge";
        }
    }
}
